module DinosaurCatalog
  module Filters
    def filter_bipeds(biped_terms)
      dinosaurs.select { |dinosaur| biped_terms.include?(dinosaur.walking.downcase) }
    end

    def filter_carnivores(carnivore_terms)
      dinosaurs.select { |dinosaur| carnivore_terms.include?(dinosaur.diet.downcase) }
    end

    def filter_periods(period_terms)
      periods_in_regex_array = Regexp.union(period_terms)
      dinosaurs.select { |dinosaur| dinosaur.period.downcase.match(periods_in_regex_array) }
    end

    def filter_sizes(size_terms)
      case
        when size_terms.include?('big') then dinosaurs.select(&:big?)
        when size_terms.include?('small') then dinosaurs.select(&:small?)
      end
    end
  end
end
